package javato.activetesting.coverage ;

import javato.activetesting.activechecker.ActiveChecker;
import java.util.* ;

/**
 * Copyright (c) 2007-2008,
 * Koushik Sen    <ksen@cs.berkeley.edu>
 * All rights reserved.
 * <p/>
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * <p/>
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * <p/>
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * <p/>
 * 3. The names of the contributors may not be used to endorse or promote
 * products derived from this software without specific prior written
 * permission.
 * <p/>
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


public class CovActiveChecker extends ActiveChecker {
	public Integer iid ;
	public Integer lock ;
	public Integer thread ;
	public Long memory ;
	public boolean readwrite ;

	public LinkedHashSet<SyncPair> notyetcovered ;

	public CovActiveChecker(Integer iid, Integer thread, Integer lock, LinkedHashSet<SyncPair> notyetcovered) {	   
		this.iid = iid ;
		this.lock = lock ;
		this.thread = thread ;
		this.notyetcovered = notyetcovered ;
	}

	public CovActiveChecker(Integer iid, Integer thread, Long memory, boolean readwrite, LinkedHashSet<SyncPair> notyetcovered) {
		this.iid = iid ;
		this.thread = thread ;
		this.memory = memory ;
		this.readwrite = readwrite ;
		this.notyetcovered = notyetcovered ;
	}

	public int score() {
		int score = 0 ;

		Iterator<SyncPair> itr = notyetcovered.iterator() ;	
		while (itr.hasNext() == true) {
			SyncPair candidate = itr.next() ;
			if (candidate.x != null && candidate.x.intValue() == this.iid.intValue() && candidate.y != null) {
				score++ ;
			}
			else if (candidate.y != null && candidate.y.intValue() == this.iid.intValue() && candidate.x != null) {			
				score++ ;
			}
		}

		return score ;
	}
}
